diff --git a/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java b/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
index f1320f4..f5bef2a 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/common/CMCOutputTemplate.java
@@ -30,16 +30,6 @@ import java.util.Hashtable;
 
 import javax.servlet.http.HttpServletResponse;
 
-import netscape.security.x509.CRLExtensions;
-import netscape.security.x509.CRLReasonExtension;
-import netscape.security.x509.CertificateChain;
-import netscape.security.x509.InvalidityDateExtension;
-import netscape.security.x509.RevocationReason;
-import netscape.security.x509.RevokedCertImpl;
-import netscape.security.x509.X500Name;
-import netscape.security.x509.X509CertImpl;
-import netscape.security.x509.X509Key;
-
 import org.mozilla.jss.CryptoManager;
 import org.mozilla.jss.asn1.ANY;
 import org.mozilla.jss.asn1.ASN1Util;
@@ -58,15 +48,18 @@ import org.mozilla.jss.pkcs11.PK11PubKey;
 import org.mozilla.jss.pkix.cert.Certificate;
 import org.mozilla.jss.pkix.cmc.CMCCertId;
 import org.mozilla.jss.pkix.cmc.CMCStatusInfo;
+import org.mozilla.jss.pkix.cmc.EncryptedPOP;
 import org.mozilla.jss.pkix.cmc.GetCert;
 import org.mozilla.jss.pkix.cmc.OtherInfo;
 import org.mozilla.jss.pkix.cmc.OtherMsg;
 import org.mozilla.jss.pkix.cmc.PendInfo;
 import org.mozilla.jss.pkix.cmc.ResponseBody;
 import org.mozilla.jss.pkix.cmc.TaggedAttribute;
+import org.mozilla.jss.pkix.cmc.TaggedRequest;
 import org.mozilla.jss.pkix.cmmf.RevRequest;
 import org.mozilla.jss.pkix.cms.ContentInfo;
 import org.mozilla.jss.pkix.cms.EncapsulatedContentInfo;
+import org.mozilla.jss.pkix.cms.EnvelopedData;
 import org.mozilla.jss.pkix.cms.IssuerAndSerialNumber;
 import org.mozilla.jss.pkix.cms.SignedData;
 import org.mozilla.jss.pkix.cms.SignerIdentifier;
@@ -89,6 +82,17 @@ import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.IRequestQueue;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.certsrv.request.RequestStatus;
+import com.netscape.cmsutil.crypto.CryptoUtil;
+
+import netscape.security.x509.CRLExtensions;
+import netscape.security.x509.CRLReasonExtension;
+import netscape.security.x509.CertificateChain;
+import netscape.security.x509.InvalidityDateExtension;
+import netscape.security.x509.RevocationReason;
+import netscape.security.x509.RevokedCertImpl;
+import netscape.security.x509.X500Name;
+import netscape.security.x509.X509CertImpl;
+import netscape.security.x509.X509Key;
 
 /**
  * Utility CMCOutputTemplate
@@ -142,6 +146,10 @@ public class CMCOutputTemplate {
 
     public void createFullResponse(HttpServletResponse resp, IRequest[] reqs,
             String cert_request_type, int[] error_codes) {
+        String method = "CMCOutputTemplate: createFullResponse: ";
+        CMS.debug(method +
+                "begins with cert_request_type=" +
+                cert_request_type);
 
         SEQUENCE controlSeq = new SEQUENCE();
         SEQUENCE cmsSeq = new SEQUENCE();
@@ -176,22 +184,33 @@ public class CMCOutputTemplate {
                     OBJECT_IDENTIFIER.id_cmc_cMCStatusInfo, cmcStatusInfo);
             controlSeq.addElement(tagattr);
         } else if (cert_request_type.equals("cmc")) {
+            CMS.debug(method + " processing cmc");
             pending_bpids = new SEQUENCE();
             success_bpids = new SEQUENCE();
             failed_bpids = new SEQUENCE();
+            EncryptedPOP encPop = null;
             if (reqs != null) {
                 for (int i = 0; i < reqs.length; i++) {
+                    CMS.debug(method + " error_codes[i]=" + error_codes[i]);
                     if (error_codes[i] == 0) {
                         success_bpids.addElement(new INTEGER(
                                 reqs[i].getExtDataInBigInteger("bodyPartId")));
                     } else if (error_codes[i] == 2) {
                         pending_bpids.addElement(new INTEGER(
                                 reqs[i].getExtDataInBigInteger("bodyPartId")));
+                        try {
+                            encPop = constructEncryptedPop(reqs[i]);
+                        } catch (Exception e) {
+                            CMS.debug(method + e);
+                            return;
+                        }
                     } else {
                         failed_bpids.addElement(new INTEGER(
                                 reqs[i].getExtDataInBigInteger("bodyPartId")));
                     }
                 }
+            } else {
+                CMS.debug(method + " reqs null.  why?");
             }
 
             TaggedAttribute tagattr = null;
@@ -221,8 +240,25 @@ public class CMCOutputTemplate {
             }
 
             if (pending_bpids.size() > 0) {
+                // handle encryptedPOP control first
+
+                if (encPop != null) {
+                    CMS.debug(method + "adding encPop");
+                    tagattr = new TaggedAttribute(
+                            new INTEGER(bpid++),
+                            OBJECT_IDENTIFIER.id_cmc_encryptedPOP,
+                            encPop);
+                    controlSeq.addElement(tagattr);
+                    CMS.debug(method + "encPop added");
+                }
+
+                String reqId = reqs[0].getRequestId().toString();
+                OtherInfo otherInfo = null;
+                PendInfo pendInfo = new PendInfo(reqId, new Date());
+                otherInfo = new OtherInfo(OtherInfo.PEND, null,
+                        pendInfo);
                 cmcStatusInfo = new CMCStatusInfo(CMCStatusInfo.PENDING,
-                        pending_bpids, (String) null, null);
+                        pending_bpids, (String) null, otherInfo);
                 tagattr = new TaggedAttribute(
                         new INTEGER(bpid++),
                         OBJECT_IDENTIFIER.id_cmc_cMCStatusInfo, cmcStatusInfo);
@@ -238,7 +274,7 @@ public class CMCOutputTemplate {
                 } catch (Exception e) {
                 }
                 if (confirmRequired) {
-                    CMS.debug("CMCOutputTemplate: confirmRequired in the request");
+                    CMS.debug(method + " confirmRequired in the request");
                     cmcStatusInfo =
                             new CMCStatusInfo(CMCStatusInfo.CONFIRM_REQUIRED,
                                     success_bpids, (String) null, null);
@@ -270,13 +306,14 @@ public class CMCOutputTemplate {
             // deal with controls
             Integer nums = (Integer) (context.get("numOfControls"));
             if (nums != null && nums.intValue() > 0) {
+                CMS.debug(method + " processing controls");
                 TaggedAttribute attr =
                         (TaggedAttribute) (context.get(OBJECT_IDENTIFIER.id_cmc_getCert));
                 if (attr != null) {
                     try {
                         processGetCertControl(attr, certs);
                     } catch (EBaseException ee) {
-                        CMS.debug("CMCOutputTemplate: " + ee.toString());
+                        CMS.debug(method + ee.toString());
                         OtherInfo otherInfo1 = new OtherInfo(OtherInfo.FAIL,
                                 new INTEGER(OtherInfo.BAD_CERT_ID), null);
                         SEQUENCE bpids1 = new SEQUENCE();
@@ -342,6 +379,10 @@ public class CMCOutputTemplate {
 
             ResponseBody respBody = new ResponseBody(controlSeq,
                     cmsSeq, otherMsgSeq);
+            if (respBody != null)
+                CMS.debug(method + " after new ResponseBody, respBody not null");
+            else
+                CMS.debug(method + " after new ResponseBody, respBody null");
 
             ContentInfo contentInfo = getContentInfo(respBody, certs);
             ByteArrayOutputStream fos = new ByteArrayOutputStream();
@@ -354,18 +395,79 @@ public class CMCOutputTemplate {
             OutputStream os = resp.getOutputStream();
             os.write(contentBytes);
             os.flush();
+            CMS.debug(method + "ends");
         } catch (java.security.cert.CertificateEncodingException e) {
-            CMS.debug("CMCOutputTemplate exception: " + e.toString());
+            CMS.debug(method + e.toString());
         } catch (InvalidBERException e) {
-            CMS.debug("CMCOutputTemplate exception: " + e.toString());
+            CMS.debug(method + e.toString());
         } catch (IOException e) {
-            CMS.debug("CMCOutputTemplate exception: " + e.toString());
+            CMS.debug(method + e.toString());
         } catch (Exception e) {
-            CMS.debug("Exception: " + e.toString());
+            CMS.debug(method + e.toString());
+        }
+    }
+
+    /**
+     * constructEncryptedPop pulls cmc pop challenge fields out of the request
+     * and constructs an EncryptedPOP
+     * to be included in the response later
+     *
+     * @author cfu
+     */
+    public EncryptedPOP constructEncryptedPop(IRequest req)
+            throws EBaseException {
+        String method = "CMCOutputTemplate: constructEncryptedPop: ";
+        CMS.debug(method + "begins");
+        EncryptedPOP encPop = null;
+
+        boolean popChallengeRequired = req.getExtDataInBoolean("cmc_POPchallengeRequired", false);
+        if (!popChallengeRequired) {
+            CMS.debug(method + "popChallengeRequired false");
+            return null;
         }
+        CMS.debug(method + "popChallengeRequired true");
+        byte[] cmc_msg = req.getExtDataInByteArray(IEnrollProfile.CTX_CERT_REQUEST);
+        byte[] pop_encreyptedData = req.getExtDataInByteArray("pop_encreyptedData");
+        //don't need this for encryptedPOP, but need to check for existence anyway
+        byte[] pop_sysPubEncreyptedSession = req.getExtDataInByteArray("pop_sysPubEncreyptedSession");
+        byte[] pop_userPubEncreyptedSession = req.getExtDataInByteArray("pop_userPubEncreyptedSession");
+        if ((pop_encreyptedData != null) &&
+                (pop_sysPubEncreyptedSession != null) &&
+                (pop_userPubEncreyptedSession != null)) {
+            // generate encryptedPOP here
+            // algs are hard-coded for now
+
+            try {
+                EnvelopedData envData = CryptoUtil.createEnvelopedData(
+                        pop_encreyptedData,
+                        pop_userPubEncreyptedSession);
+                ContentInfo ci = new ContentInfo(envData);
+                CMS.debug(method + "now we can compose encryptedPOP");
+
+                TaggedRequest.Template tReqTemplate = new TaggedRequest.Template();
+                TaggedRequest tReq = (TaggedRequest) tReqTemplate.decode(
+                        new ByteArrayInputStream(cmc_msg));
+
+                encPop = new EncryptedPOP(
+                        tReq,
+                        ci,
+                        CryptoUtil.getDefaultEncAlg(),
+                        CryptoUtil.getDefaultHashAlg(),
+                        new OCTET_STRING(req.getExtDataInByteArray("pop_witness")));
+
+            } catch (Exception e) {
+                CMS.debug(method + " excepton:" + e);
+                throw new EBaseException(method + " excepton:" + e);
+            }
+
+        }
+
+        return encPop;
     }
 
     private ContentInfo getContentInfo(ResponseBody respBody, SET certs) {
+        String method = "CMCOutputTemplate: getContentInfo: ";
+        CMS.debug(method + "begins");
         try {
             ICertificateAuthority ca = null;
             // add CA cert chain
@@ -442,10 +544,10 @@ public class CMCOutputTemplate {
                     enContentInfo, certs, null, signInfos);
 
             ContentInfo contentInfo = new ContentInfo(signedData);
-            CMS.debug("CMCOutputTemplate::getContentInfo() - done");
+            CMS.debug(method + " - done");
             return contentInfo;
         } catch (Exception e) {
-            CMS.debug("CMCOutputTemplate: Failed to create CMCContentInfo. Exception: " + e.toString());
+            CMS.debug(method + " Failed to create CMCContentInfo. Exception: " + e.toString());
         }
         return null;
     }
diff --git a/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java b/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
index 6191031..c233e41 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
@@ -28,8 +28,6 @@ import javax.servlet.ServletException;
 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.http.HttpServletResponse;
 
-import netscape.security.x509.X509CertImpl;
-
 import org.mozilla.jss.asn1.ASN1Util;
 import org.mozilla.jss.asn1.INTEGER;
 import org.mozilla.jss.asn1.InvalidBERException;
@@ -58,6 +56,7 @@ import com.netscape.certsrv.profile.IProfileInput;
 import com.netscape.certsrv.profile.IProfileSubsystem;
 import com.netscape.certsrv.request.INotify;
 import com.netscape.certsrv.request.IRequest;
+import com.netscape.certsrv.request.RequestId;
 import com.netscape.certsrv.request.RequestStatus;
 import com.netscape.cms.servlet.common.AuthCredentials;
 import com.netscape.cms.servlet.common.CMCOutputTemplate;
@@ -65,6 +64,8 @@ import com.netscape.cms.servlet.common.CMSRequest;
 import com.netscape.cms.servlet.common.CMSTemplate;
 import com.netscape.cmsutil.util.Utils;
 
+import netscape.security.x509.X509CertImpl;
+
 /**
  * This servlet submits end-user request into the profile framework.
  *
@@ -478,12 +479,13 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
         TaggedAttribute attr =
                 (TaggedAttribute) (context.get(OBJECT_IDENTIFIER.id_cmc_lraPOPWitness));
         if (attr != null) {
-            boolean verifyAllow = true;
+            boolean verifyAllow = false; //disable RA by default
             try {
                 verifyAllow = CMS.getConfigStore().getBoolean(
-                        "cmc.lraPopWitness.verify.allow", true);
+                        "cmc.lraPopWitness.verify.allow", false);
             } catch (EBaseException ee) {
             }
+            CMS.debug("ProfileSubmitCMCServlet: cmc.lraPopWitness.verify.allow is " + verifyAllow);
 
             if (!verifyAllow) {
                 LraPopWitness lraPop = null;
@@ -507,23 +509,34 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
             }
         }
 
-        // for CMC, requests may be zero. Then check if controls exist.
+        // For CMC, requests may be zero. Then check if controls exist.
+        // In case of decryptedPOP, request already exists, find it and
+        // put in provedReq.
+        IRequest provedReq = null;
         if (reqs == null) {
-            Integer nums = (Integer) (context.get("numOfControls"));
-            CMCOutputTemplate template = new CMCOutputTemplate();
-            // if there is only one control GetCert, then simple response
-            // must be returned.
-            if (nums != null && nums.intValue() == 1) {
-                TaggedAttribute attr1 = (TaggedAttribute) (context.get(OBJECT_IDENTIFIER.id_cmc_getCert));
-                if (attr1 != null) {
-                    template.createSimpleResponse(response, reqs);
+            // handling DecryptedPOP request here
+            Integer reqID = (Integer) context.get("decryptedPopReqId");
+            provedReq = profile.getRequestQueue().findRequest(new RequestId(reqID.toString()));
+            if (provedReq == null) {
+
+                Integer nums = (Integer) (context.get("numOfControls"));
+                CMCOutputTemplate template = new CMCOutputTemplate();
+                // if there is only one control GetCert, then simple response
+                // must be returned.
+                if (nums != null && nums.intValue() == 1) {
+                    TaggedAttribute attr1 = (TaggedAttribute) (context.get(OBJECT_IDENTIFIER.id_cmc_getCert));
+                    if (attr1 != null) {
+                        template.createSimpleResponse(response, reqs);
+                    } else
+                        template.createFullResponse(response, reqs,
+                                cert_request_type, null);
                 } else
                     template.createFullResponse(response, reqs,
                             cert_request_type, null);
-            } else
-                template.createFullResponse(response, reqs,
-                        cert_request_type, null);
-            return;
+                return;
+            } else {
+                CMS.debug("ProfileSubmitCMCServlet: provedReq not null");
+            }
         }
 
         String errorCode = null;
@@ -532,7 +545,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
         ///////////////////////////////////////////////
         // populate request
         ///////////////////////////////////////////////
-        for (int k = 0; k < reqs.length; k++) {
+        for (int k = 0; (provedReq == null) &&(k < reqs.length); k++) {
             // adding parameters to request
             setInputsIntoRequest(request, profile, reqs[k]);
 
@@ -626,7 +639,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
                         OtherInfo.INTERNAL_CA_ERROR, s);
                 return;
             }
-        }
+        } //for
 
         String auditMessage = null;
         String auditSubjectID = auditSubjectID();
@@ -640,7 +653,8 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
             int error_codes[] = null;
             if (reqs != null && reqs.length > 0)
                 error_codes = new int[reqs.length];
-            for (int k = 0; k < reqs.length; k++) {
+
+            for (int k = 0; (provedReq == null) && (k < reqs.length); k++) {
                 try {
                     // reset the "auditRequesterID"
                     auditRequesterID = auditRequesterID(reqs[k]);
@@ -680,6 +694,7 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
                     }
                 } catch (EDeferException e) {
                     // return defer message to the user
+                    CMS.debug("ProfileSubmitCMCServlet: set request to PENDING");
                     reqs[k].setRequestStatus(RequestStatus.PENDING);
                     // need to notify
                     INotify notify = profile.getRequestQueue().getPendingNotify();
@@ -752,6 +767,53 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
                     error_codes[k] = 0;
             }
 
+            // handle provedReq
+            if (provedReq != null) {
+                error_codes = new int[1];
+                auditRequesterID = auditRequesterID(provedReq);
+                try {
+                    profile.execute(provedReq);
+                    reqs = new IRequest[1];
+                    reqs[0] = provedReq;
+                    reqs[0].setRequestStatus(RequestStatus.COMPLETE);
+                    profile.getRequestQueue().markAsServiced(provedReq);
+                    CMS.debug("ProfileSubmitCMCServlet: provedReq set to complete");
+
+                    // reset the "auditInfoCertValue"
+                    auditInfoCertValue = auditInfoCertValue(reqs[0]);
+
+                    if (auditInfoCertValue != null) {
+                        if (!(auditInfoCertValue.equals(
+                                ILogger.SIGNED_AUDIT_EMPTY_VALUE))) {
+                            // store a message in the signed audit log file
+                            auditMessage = CMS.getLogMessage(
+                                    LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED,
+                                    auditSubjectID,
+                                    ILogger.SUCCESS,
+                                    auditRequesterID,
+                                    ILogger.SIGNED_AUDIT_ACCEPTANCE,
+                                    auditInfoCertValue);
+
+                            audit(auditMessage);
+                        }
+                    }
+                } catch (ERejectException e) {
+                    // return error to the user
+                    provedReq.setRequestStatus(RequestStatus.REJECTED);
+                    CMS.debug("ProfileSubmitCMCServlet: provedReq submit " + e.toString());
+                    errorCode = "3";
+                    errorReason = CMS.getUserMessage(locale,
+                            "CMS_PROFILE_REJECTED",
+                            e.toString());
+                } catch (Exception e) {
+                    // return error to the user
+                    CMS.debug("ProfileSubmitCMCServlet: provedReq submit " + e.toString());
+                    errorCode = "1";
+                    errorReason = CMS.getUserMessage(locale,
+                            "CMS_INTERNAL_ERROR");
+                }
+            }
+
             if (errorCode != null) {
                 // create the CMC full enrollment response
                 CMCOutputTemplate template = new CMCOutputTemplate();
diff --git a/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java b/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
index e3a378e..716a3f2 100644
--- a/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
+++ b/base/util/src/com/netscape/cmsutil/crypto/CryptoUtil.java
@@ -55,10 +55,13 @@ import org.mozilla.jss.asn1.ANY;
 import org.mozilla.jss.asn1.ASN1Util;
 import org.mozilla.jss.asn1.ASN1Value;
 import org.mozilla.jss.asn1.BIT_STRING;
+import org.mozilla.jss.asn1.INTEGER;
 import org.mozilla.jss.asn1.InvalidBERException;
+import org.mozilla.jss.asn1.NULL;
 import org.mozilla.jss.asn1.OBJECT_IDENTIFIER;
 import org.mozilla.jss.asn1.OCTET_STRING;
 import org.mozilla.jss.asn1.SEQUENCE;
+import org.mozilla.jss.asn1.SET;
 import org.mozilla.jss.crypto.Algorithm;
 import org.mozilla.jss.crypto.BadPaddingException;
 import org.mozilla.jss.crypto.Cipher;
@@ -89,7 +92,11 @@ import org.mozilla.jss.crypto.X509Certificate;
 import org.mozilla.jss.pkcs11.PK11ECPublicKey;
 import org.mozilla.jss.pkcs11.PK11PubKey;
 import org.mozilla.jss.pkcs12.PasswordConverter;
-import org.mozilla.jss.pkcs7.EncryptedContentInfo;
+import org.mozilla.jss.pkcs7.IssuerAndSerialNumber;
+import org.mozilla.jss.pkcs7.RecipientInfo;
+import org.mozilla.jss.pkix.cms.ContentInfo;
+import org.mozilla.jss.pkix.cms.EncryptedContentInfo;
+import org.mozilla.jss.pkix.cms.EnvelopedData;
 import org.mozilla.jss.pkix.crmf.CertReqMsg;
 import org.mozilla.jss.pkix.crmf.CertRequest;
 import org.mozilla.jss.pkix.crmf.CertTemplate;
@@ -2391,6 +2398,41 @@ public class CryptoUtil {
     }
 
     /**
+     * for CMC encryptedPOP
+     */
+    public static EnvelopedData createEnvelopedData(byte[] encContent, byte[] encSymKey)
+            throws Exception {
+        String method = "CryptoUtl: createEnvelopedData: ";
+        System.out.println(method + "begins");
+
+        EncryptedContentInfo encCInfo = new EncryptedContentInfo(
+                ContentInfo.DATA,
+                getDefaultEncAlg(),
+                new OCTET_STRING(encContent));
+
+        Name name = new Name();
+        name.addCommonName("unUsedIssuerName"); //unused; okay for cmc EncryptedPOP
+        RecipientInfo recipient = new RecipientInfo(
+                new INTEGER(0), //per rfc2315
+                new IssuerAndSerialNumber(name, new INTEGER(0)), //unUsed
+                new AlgorithmIdentifier(RSA_ENCRYPTION, new NULL()),
+                new OCTET_STRING(encSymKey));
+
+        SET recipients = new SET();
+        recipients.addElement(recipient);
+
+        EnvelopedData envData = new EnvelopedData(
+                new INTEGER(0),
+                recipients,
+                encCInfo);
+
+        return envData;
+    }
+
+    /* PKCS 1 - rsaEncryption */
+    public static OBJECT_IDENTIFIER RSA_ENCRYPTION = new OBJECT_IDENTIFIER(new long[] { 1, 2, 840, 113549, 1, 1, 1 });
+
+    /**
      * The following are convenience routines for quick preliminary
      * feature development or test programs that would just take
      * the defaults
@@ -2538,6 +2580,32 @@ public class CryptoUtil {
         }
         return oid;
     }
+
+    /**
+     * getNameFromHashAlgorithm returns the hashing algorithm name
+     * from input Algorithm
+     *
+     * @param ai the hashing algorithm AlgorithmIdentifier
+     * @return name of the hashing algorithm
+     *
+     */
+    public static String getNameFromHashAlgorithm(AlgorithmIdentifier ai)
+           throws NoSuchAlgorithmException {
+        OBJECT_IDENTIFIER oid = null;
+
+        System.out.println("CryptoUtil: getNameFromHashAlgorithm: " + ai.getOID().toString());
+        if (ai != null) {
+            if (ai.getOID().equals((DigestAlgorithm.SHA256).toOID())) {
+                return "SHA-256";
+            } else if (ai.getOID().equals((DigestAlgorithm.SHA384).toOID())) {
+                return "SHA-384";
+            } else if (ai.getOID().equals((DigestAlgorithm.SHA512).toOID())) {
+                return "SHA-512";
+            }
+        }
+        throw new NoSuchAlgorithmException();
+    }
+
 }
 
 // START ENABLE_ECC
-- 
2.7.4

